/**
 *  VL
 *  
 *  This class creates a vertical line object, which is useful for connecting
 *  iterations for Newton's method display
 *
 * @author Sarah Greer
 * @see Line
 * @see Function
 * @see Plot
 *
 */

class VL extends Line{
  float[] y;    // array for y values
  float[] ymap; // y mapped to pixels
  int ny;       // number of y
  int fmapMax;  // maximum xmap values

  VL(Plot plot, Function function, int mx){
    super(plot, function, mx);
  }
  
  // update graph
  void graphUpdate(){
    super.graphUpdate();
    ny = plot.ny;
    y = plot.y;
    ymap = plot.ymap;
  }

  // generate "function" (technically not a function but oh well)
  void generateFunction(){
    float xm = getXMap0();
    for (int i = 0; i < ny; i++){
      fmap[i] = xm;
    }
  }

  // get y intercept for line
  int getYMap0(){
    return height-int((functionForDisplay(-b/m)-miny)/dy);
  }

  // check if iterations are complete
  Boolean isComplete(){
    return mx == getBMap();
  }

  // find the next x guess
  int getNewX(){
    return int(fmap[0]);
  }

  // display vertical line
  void display(){
    getXMap0();
    getBMap();
    float y2 = functionForDisplay(-b/m);
    color c = #4c4cff;
    strokeWeight(2);
    for (int i = 1; i < ny; i++){
      if (y2 >= 0 ){
          if (i<getBMap() && i>getYMap0()){
          line(fmap[i-1],ymap[i-1],fmap[i],ymap[i]);
          }
      } else if (y2 < 0){
          if (i>getBMap() && i<getYMap0()){
          line(fmap[i-1],ymap[i-1],fmap[i],ymap[i]);
          }
      }
    }
  }
}
